<?php
/***************************************************************************
 *                              chess_posting.php
 *                      ---------------------------------
 *   begin                : Saturday, April 8, 2006
 *   copyright            : (C) 2006 M. Yahya, boo.ifreepages.com 
 *   email                : mr.boo@telkom,net
 *
 *   $Id: chess_posting.php,v 0.0.1 2006/4/16 20:00:00 M. Yahya Exp $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
}

include('chess_table_select.'.$phpEx);
include('chess_table_delete.'.$phpEx);
	
function chess_posting_on_mode ()
{
	global $mode, $is_auth_type, $topic_id, $post_id, $lang, $sql;
	
	switch( $mode )
	{
		case 'chess_delete':
			$is_auth_type = 'auth_chess_create';
			if ( empty( $post_id) )
			{
				message_die(GENERAL_MESSAGE, $lang['No_post_id']);
			}

			$sql = "SELECT f.*, t.topic_id, t.topic_status, t.topic_type, t.topic_first_post_id, t.topic_last_post_id, t.topic_chess 
				FROM " . POSTS_TABLE . " p, " . TOPICS_TABLE . " t, " . FORUMS_TABLE . " f 
				WHERE p.post_id = $post_id 
					AND t.topic_id = p.topic_id 
					AND f.forum_id = t.forum_id";
			break;
		case 'chess_join':
		case 'chess_play':
			$is_auth_type = 'auth_chess_play';
			if ( empty( $topic_id) )
			{
				message_die(GENERAL_MESSAGE, $lang['No_topic_id']);
			}

			$sql = "SELECT f.*, t.topic_status, t.topic_type 
				FROM " . FORUMS_TABLE . " f, " . TOPICS_TABLE . " t 
				WHERE t.topic_id = $topic_id 
					AND f.forum_id = t.forum_id";
			break;
	}
}

function chess_posting_get_id ()
{
	global $board_config, $mode, $is_auth, $post_data, $post_info, $lang, $topic_id, $post_id;

	if ( $mode == 'editpost' || $mode == 'delete' || $mode == 'chess_delete' )
	{
		$topic_id = $post_info['topic_id'];

		$post_data['first_post'] = ( $post_info['topic_first_post_id'] == $post_id ) ? true : false;
		
		if ( $post_data['first_post'] )
		{
			$row = chess_table_select ( '*', $topic_id, 'Could not obtain chess game data for this topic', 'LIMIT 1' );

			if ( $row )
			{
				$chess_id = $row['chess_id'];
			}
		}
	
		$post_data['delete_chess'] = ($post_data['first_post'] && isset($chess_id) && $is_auth['auth_chess_create']) ? true : false;
	
		if ( !$post_data['delete_chess'] && $mode == 'chess_delete' )
		{
			message_die(GENERAL_MESSAGE, $lang['Cannot_delete_chess']);
		}
	}
	else
	{
		$chess_id = false;
		$post_data['delete_chess'] = false;
	}

	if ($mode == 'chess_delete' && !isset($chess_id))
	{
		message_die(GENERAL_MESSAGE, $lang['No_such_post']);
	}

	return $chess_id;
}

function chess_posting_delete ()
{
	global $board_config, $theme, $phpbb_root_path, $phpEx, $template, $lang, $post_id, $db, $userdata, $nav_links;

	$s_hidden_fields = '<input type="hidden" name="' . POST_POST_URL . '" value="' . $post_id . '" />';
	$s_hidden_fields .= '<input type="hidden" name="mode" value="chess_delete"';
	$s_hidden_fields .= '" />';
	
	include($phpbb_root_path . 'includes/page_header.'.$phpEx);

	$template->set_filenames(array(
		'confirm_body' => 'confirm_body.tpl')
	);

	$template->assign_vars(array(
		'MESSAGE_TITLE' => $lang['Information'],
		'MESSAGE_TEXT' => $lang['Confirm_delete_chess'],

		'L_YES' => $lang['Yes'],
		'L_NO' => $lang['No'],

		'S_CONFIRM_ACTION' => append_sid("posting.$phpEx"),
		'S_HIDDEN_FIELDS' => $s_hidden_fields)
	);

	$template->pparse('confirm_body');

	include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
}

function chess_posting_join ()
{
	global $chess_join, $db, $template, $phpEx, $userdata, $lang, $topic_id;

//
// *** added by Zlodey (for Chess+) ***
$sql = "SELECT stavka_or, chess_p1_id FROM " . CHESS_TABLE . " WHERE topic_id = $topic_id LIMIT 1";
if (!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, " ", '', __LINE__, __FILE__, $sql);
	}
$temp5 = $db->sql_fetchrow($result);
$stavka_or_2 = ($temp5['chess_p1_id']) ? ($temp5['stavka_or'] * 0.8) : ($temp5['stavka_or'] * 1.2);
$user_reputation = $userdata['user_reputation'];
if ($user_reputation >= $stavka_or_2)
{	
// *** added by Zlodey (for Chess+) ***
//

	if ( !empty($chess_join['chess_join']) )
	{
		$chess_location = intval($chess_join['chess_location']);

		$chess_info = chess_table_select ( '*', $topic_id, 'Could not obtain chess game data for this topic', 'LIMIT 1' );

//
// *** added by Zlodey (for Chess+) ***
		$stavka_or = $chess_info['stavka_or'];
		$bank_or = 2 * $stavka_or;
// *** added by Zlodey (for Chess+) ***
//

		if ( $chess_info  )
		{
			if ( $chess_info['chess_p1_id'] == 0 )
			{

//
// *** replaced by Zlodey (for Chess+) ***
//				$sql = "UPDATE " . CHESS_TABLE . " 
//					SET chess_p1_id = " . $userdata['user_id'] . ", 
//					chess_p1_pref = $chess_location, 
//					chess_turn = " . $userdata['user_id'] . ", 
//					chess_list_move = '|', 
//					chess_start = " . date("U") . " 
//					WHERE topic_id = $topic_id 
//					LIMIT 1";
				$sql = "UPDATE " . CHESS_TABLE . " 
					SET chess_p1_id = " . $userdata['user_id'] . ", 
					chess_p1_pref = $chess_location, 
					chess_turn = " . $userdata['user_id'] . ", 
					chess_list_move = '|', 
bank_or = $bank_or,
					chess_start = " . date("U") . " 
					WHERE topic_id = $topic_id 
					LIMIT 1";
// *** replaced by Zlodey (for Chess+) ***
//

			}
			else if ( $chess_info['chess_p2_id'] == 0 )
			{

//
// *** replaced by Zlodey (for Chess+) ***
//				$sql = "UPDATE " . CHESS_TABLE . " 
//					SET chess_p2_id = " . $userdata['user_id'] . ", 
//					chess_p2_pref = $chess_location, 
//					chess_list_move = '|', 
//					chess_start = " . date("U") . " 
//					WHERE topic_id = $topic_id 
//					LIMIT 1";
				$sql = "UPDATE " . CHESS_TABLE . " 
					SET chess_p2_id = " . $userdata['user_id'] . ", 
					chess_p2_pref = $chess_location, 
					chess_list_move = '|', 
bank_or = $bank_or,
					chess_start = " . date("U") . " 
					WHERE topic_id = $topic_id 
					LIMIT 1";
// *** replaced by Zlodey (for Chess+) ***
//

			}
			
			if ( $result = $db->sql_query($sql) )
			{

//
// *** added by Zlodey (for Chess+) ***
		$user_reputation = $user_reputation - $stavka_or_2;
		$user_id = $userdata['user_id'];
		$sql = "UPDATE " . USERS_TABLE . " SET user_reputation = $user_reputation WHERE user_id = $user_id LIMIT 1";
		if( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, " ", '', __LINE__, __FILE__, $sql);
			}
// *** added by Zlodey (for Chess+) ***
//

				$message = $lang['Chess_joined'];
			}
			else
			{
				$message = $lang['Chess_already_joined'];
			}
		}
		$template->assign_vars(array(
			'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id") . '">')
		);
		$message .=  '<br /><br />' . sprintf($lang['Click_return_topic'], '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id") . '">', '</a>');
		message_die(GENERAL_MESSAGE, $message);
	}
	else
	{
		redirect(append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id", true));
	}

//
// *** added by Zlodey (for Chess+) ***
}
else
{
		$template->assign_vars(array(
			'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id") . '">')
		);
		$message = '    <br /><br />' . sprintf('<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id") . '"></a>');
		message_die(GENERAL_MESSAGE, $message);
}
// *** added by Zlodey (for Chess+) ***
//

}

function chess_posting_square_under_attack ( $cs, $clp, $xpos, $ypos, $diss_x, $diss_y )
{
	$s = $cs == 'W' ? -1 : 1;
	$o = $cs == 'W' ? 'B' : 'W';

	$check_list = '';

	$check_list .= $clp[$ypos + $s][$xpos - 1] == $o ? ($xpos - 1) . ($ypos + $s) . "," : "";
	$check_list .= $clp[$ypos + $s][$xpos + 1] == $o ? ($xpos + 1) . ($ypos + $s) . "," : "";
	
	$x = $xpos; $y = $ypos; while ( ($clp[$y][$x - 1] == '' || ($x - 1 == $diss_x && $y == $diss_y) ) && $x - 1 >= 0 ) $x--;
	if ( ($clp[$y][$x - 1] == $o . "Q" || $clp[$y][$x - 1] == $o . "R") && $x - 1 >= 0 ) $check_list .= ($x - 1) . $y . ",";
	$x = $xpos; $y = $ypos; while ( ($clp[$y][$x + 1] == '' || ($x + 1 == $diss_x && $y == $diss_y) ) && $x + 1 < 8 ) $x++;
	if ( ($clp[$y][$x + 1] == $o . "Q" || $clp[$y][$x + 1] == $o . "R") && $x + 1 < 8 ) $check_list .= ($x + 1) . $y . ",";
	$x = $xpos; $y = $ypos; while ( ($clp[$y - 1][$x] == '' || ($x == $diss_x && $y - 1 == $diss_y) ) && $y - 1 >= 0 ) $y--;
	if ( ($clp[$y - 1][$x] == $o . "Q" || $clp[$y - 1][$x] == $o . "R") && $y - 1 >= 0 ) $check_list .= $x . ($y - 1) . ",";
	$x = $xpos; $y = $ypos; while ( ($clp[$y + 1][$x] == '' || ($x == $diss_x && $y + 1 == $diss_y) ) && $y + 1 < 8 ) $y++;
	if ( ($clp[$y + 1][$x] == $o . "Q" || $clp[$y + 1][$x] == $o . "R") && $y + 1 < 8 ) $check_list .= $x . ($y + 1) . ",";
	$x = $xpos; $y = $ypos; while ( ($clp[$y - 1][$x - 1] == '' || ($x - 1 == $diss_x && $y - 1 == $diss_y) ) && $y - 1 >= 0 && $x - 1 >= 0 ) { $x--; $y--; }
	if ( ($clp[$y - 1][$x - 1] == $o . "Q" || $clp[$y - 1][$x - 1] == $o . "B") && $y - 1 >= 0 && $x - 1 >= 0 ) $check_list .= ($x - 1) . ($y - 1) . ",";
	$x = $xpos; $y = $ypos; while ( ($clp[$y - 1][$x + 1] == '' || ($x + 1 == $diss_x && $y - 1 == $diss_y) ) && $y - 1 >= 0 && $x + 1 < 8 ) { $x++; $y--; }
	if ( ($clp[$y - 1][$x + 1] == $o . "Q" || $clp[$y - 1][$x + 1] == $o . "B") && $y - 1 >= 0 && $x + 1 < 8 ) $check_list .= ($x + 1) . ($y - 1) . ",";
	$x = $xpos; $y = $ypos; while ( ($clp[$y + 1][$x - 1] == '' || ($x - 1 == $diss_x && $y + 1 == $diss_y) ) && $y + 1 < 8 && $x - 1 >= 0 ) { $x--; $y++; }
	if ( ($clp[$y + 1][$x - 1] == $o . "Q" || $clp[$y + 1][$x - 1] == $o . "B") && $y + 1 < 8 && $x - 1 >= 0 ) $check_list .= ($x - 1) . ($y + 1) . ",";
	$x = $xpos; $y = $ypos; while ( ($clp[$y + 1][$x + 1] == '' || ($x + 1 == $diss_x && $y + 1 == $diss_y) ) && $y + 1 < 8 && $x + 1 < 8 ) { $x++; $y++; }
	if ( ($clp[$y + 1][$x + 1] == $o . "Q" || $clp[$y + 1][$x + 1] == $o . "B") && $y + 1 < 8 && $x + 1 < 8 ) $check_list .= ($x + 1) . ($y + 1) . ",";

	if ( $clp[$ypos - 2][$xpos - 1] == $o . "N" && $ypos - 2 >= 0 && $xpos - 1 >= 0 ) $check_list .= ($xpos - 1) . ($ypos - 2) . ",";
	if ( $clp[$ypos - 2][$xpos + 1] == $o . "N" && $ypos - 2 >= 0 && $xpos + 1 < 8 ) $check_list .= ($xpos + 1) . ($ypos - 2) . ",";
	if ( $clp[$ypos + 2][$xpos - 1] == $o . "N" && $ypos + 2 < 8 && $xpos - 1 >= 0 ) $check_list .= ($xpos - 1) . ($ypos + 2) . ",";
	if ( $clp[$ypos + 2][$xpos + 1] == $o . "N" && $ypos + 2 < 8 && $xpos + 1 < 8 ) $check_list .= ($xpos + 1) . ($ypos + 2) . ",";
	if ( $clp[$ypos - 1][$xpos - 2] == $o . "N" && $ypos - 1 >= 0 && $xpos - 2 >= 0 ) $check_list .= ($xpos - 2) . ($ypos - 1) . ",";
	if ( $clp[$ypos - 1][$xpos + 2] == $o . "N" && $ypos - 1 >= 0 && $xpos + 2 < 8 ) $check_list .= ($xpos + 2) . ($ypos - 1) . ",";
	if ( $clp[$ypos + 1][$xpos - 2] == $o . "N" && $ypos + 1 < 8 && $xpos - 2 >= 0 ) $check_list .= ($xpos - 2) . ($ypos + 1) . ",";
	if ( $clp[$ypos + 1][$xpos + 2] == $o . "N" && $ypos + 1 < 8 && $xpos + 2 < 8 ) $check_list .= ($xpos + 2) . ($ypos + 1) . ",";
	
	$check_list = $check_list[ strlen($check_list) - 1 ] == ',' ? substr($check_list, 0, strlen($check_list) - 1) : $check_list;

	return $check_list;
}

function chess_posting_check_move( $cs, $clp, &$clv, $cc )
{
	$s = $cs == 'W' ? -1 : 1;
	$o = $cs == 'W' ? 'B' : 'W';
	$cp = $cs == 'W' ? $cc & 3 : ($cc & 12) >> 2;
	$k = "";
	
	$a = array( 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h' );
	
	for( $r = 0; $r < 8; $r++ )
	{
		for( $c = 0; $c < 8; $c++ )
		{
			switch ( $clp[$r][$c] )
			{
				case $cs : 
				{
					if ($r == 1 && $clp[$r + 1][$c] == '' && $clp[$r + 2][$c] == '' && $cs == 'B') $clv .= $a[$c] . "75,";
					if ($r == 6 && $clp[$r - 1][$c] == '' && $clp[$r - 2][$c] == '' && $cs == 'W') $clv .= $a[$c] . "24,";
					
					if ($clp[$r + $s][$c] == '') $clv .= $a[$c] . (8 - $r) . (8 - ($r + $s)) . ",";
					if ($clp[$r + $s][$c + 1][0] == $o) $clv .= $a[$c] . (8 - $r) . $a[$c + 1] . (8 - ($r + $s)) . ",";
					if ($clp[$r + $s][$c - 1][0] == $o) $clv .= $a[$c] . (8 - $r) . $a[$c - 1] . (8 - ($r + $s)) . ",";
				}
				break;
				case $cs . 'K' : 
				{
					$k = $c . $r;

					$kx = (int) $k[0];
					$ky = (int) $k[1];

					$kcl = chess_posting_square_under_attack ( $cs, $clp, $kx, $ky, $kx, $ky );

					if ( ($clp[$r][$c - 1][0] == $o || $clp[$r][$c - 1] == '') && $c - 1 >= 0 ) $clv .= $a[$c] . (8 - $r) . $a[$c - 1] . ",";
					if ( ($clp[$r - 1][$c][0] == $o || $clp[$r - 1][$c] == '') && $r - 1 >= 0 ) $clv .= $a[$c] . (8 - $r) . (8 - ($r - 1)) . ",";
					if ( ($clp[$r + 1][$c][0] == $o || $clp[$r + 1][$c] == '') && $r + 1 < 8 ) $clv .= $a[$c] . (8 - $r) . (8 - ($r + 1)) . ",";
					if ( ($clp[$r][$c + 1][0] == $o || $clp[$r][$c + 1] == '') && $c + 1 < 8 ) $clv .= $a[$c] . (8 - $r) . $a[$c + 1] . ",";
					if ( ($clp[$r - 1][$c - 1][0] == $o || $clp[$r - 1][$c - 1] == '') && $r - 1 >= 0 && $c - 1 >= 0 ) $clv .= $a[$c] . (8 - $r) . $a[$c - 1] . (8 - ($r - 1)) . ",";
					if ( ($clp[$r - 1][$c + 1][0] == $o || $clp[$r - 1][$c + 1] == '') && $r - 1 >= 0 && $c + 1 < 8 ) $clv .= $a[$c] . (8 - $r) . $a[$c + 1] . (8 - ($r - 1)) . ",";
					if ( ($clp[$r + 1][$c - 1][0] == $o || $clp[$r + 1][$c - 1] == '') && $r + 1 < 8 && $c - 1 >= 0 ) $clv .= $a[$c] . (8 - $r) . $a[$c - 1] . (8 - ($r + 1)) . ",";
					if ( ($clp[$r + 1][$c + 1][0] == $o || $clp[$r + 1][$c + 1] == '') && $r + 1 < 8 && $c + 1 < 8 ) $clv .= $a[$c] . (8 - $r) . $a[$c + 1] . (8 - ($r + 1)) . ",";
					
					if (empty($kcl))
					{
						if (($cp & 1) == 0 && $clp[$r][$c + 1] == '' && $clp[$r][$c + 2] == '') 
						{
							if (
								chess_posting_square_under_attack ( $cs, $clp, $c + 1, $r, $c + 1, $r ) == '' && 
								chess_posting_square_under_attack ( $cs, $clp, $c + 2, $r, $c + 2, $r ) == ''
							)
							{
								$clv .= $a[$c] . (8 - $r) . $a[$c + 2] . ",";
							}
						}
						if (($cp & 2) == 0 && $clp[$r][$c - 1] == '' && $clp[$r][$c - 2] == '' && $clp[$r][$c - 3] == '')
						{
							if (
								chess_posting_square_under_attack ( $cs, $clp, $c - 1, $r, $c - 1, $r ) == '' && 
								chess_posting_square_under_attack ( $cs, $clp, $c - 2, $r, $c - 2, $r ) == ''
							)
							{
								$clv .= $a[$c] . (8 - $r) . $a[$c - 2] . ",";
							}
						}
					}
				}
				break;
				case $cs . 'N' :
				{
					if ( ($clp[$r - 2][$c - 1][0] == $o || $clp[$r - 2][$c - 1] == '')&& $r - 2 >= 0 && $c - 1 >= 0 ) $clv .= $a[$c] . (8 - $r) . $a[$c - 1] . (8 - ($r - 2)) . ",";
					if ( ($clp[$r - 2][$c + 1][0] == $o || $clp[$r - 2][$c + 1] == '')&& $r - 2 >= 0 && $c + 1 < 8 ) $clv .= $a[$c] . (8 - $r) . $a[$c + 1] . (8 - ($r - 2)) . ",";
					if ( ($clp[$r + 2][$c - 1][0] == $o || $clp[$r + 2][$c - 1] == '')&& $r + 2 < 8 && $c - 1 >= 0 ) $clv .= $a[$c] . (8 - $r) . $a[$c - 1] . (8 - ($r + 2)) . ",";
					if ( ($clp[$r + 2][$c + 1][0] == $o || $clp[$r + 2][$c + 1] == '')&& $r + 2 < 8 && $c + 1 < 8 ) $clv .= $a[$c] . (8 - $r) . $a[$c + 1] . (8 - ($r + 2)) . ",";
					if ( ($clp[$r - 1][$c - 2][0] == $o || $clp[$r - 1][$c - 2] == '')&& $r - 1 >= 0 && $c - 2 >= 0 ) $clv .= $a[$c] . (8 - $r) . $a[$c - 2] . (8 - ($r - 1)) . ",";
					if ( ($clp[$r - 1][$c + 2][0] == $o || $clp[$r - 1][$c + 2] == '')&& $r - 1 >= 0 && $c + 2 < 8 ) $clv .= $a[$c] . (8 - $r) . $a[$c + 2] . (8 - ($r - 1)) . ",";
					if ( ($clp[$r + 1][$c - 2][0] == $o || $clp[$r + 1][$c - 2] == '')&& $r + 1 < 8 && $c - 2 >= 0 ) $clv .= $a[$c] . (8 - $r) . $a[$c - 2] . (8 - ($r + 1)) . ",";
					if ( ($clp[$r + 1][$c + 2][0] == $o || $clp[$r + 1][$c + 2] == '')&& $r + 1 < 8 && $c + 2 < 8 ) $clv .= $a[$c] . (8 - $r) . $a[$c + 2] . (8 - ($r + 1)) . ",";
				}
				break;
				case $cs . 'B' :
				{
					$x = $c; $y = $r;
					while ( $clp[$y - 1][$x - 1] == '' && $y - 1 >= 0 && $x - 1 >= 0 )
					{
						$clv .= $a[$c] . (8 - $r) . $a[$x - 1] . (8 - ($y - 1)) . ",";
						$x--; $y--;
					}
					if ( $clp[$y - 1][$x - 1][0] == $o && $y - 1 >= 0 && $x - 1 >= 0 ) $clv .= $a[$c] . (8 - $r) . $a[$x - 1] . (8 - ($y - 1)) . ",";
					
					$x = $c; $y = $r;
					while ( $clp[$y - 1][$x + 1] == '' && $y - 1 >= 0 && $x + 1 < 8 )
					{
						$clv .= $a[$c] . (8 - $r) . $a[$x + 1] . (8 - ($y - 1)) . ",";
						$x++; $y--;
					}
					if ( $clp[$y - 1][$x + 1][0] == $o && $y - 1 >= 0 && $x + 1 < 8 ) $clv .= $a[$c] . (8 - $r) . $a[$x + 1] . (8 - ($y - 1)) . ",";
					
					$x = $c; $y = $r;
					while ( $clp[$y + 1][$x - 1] == '' && $y + 1 < 8 && $x - 1 >= 0 )
					{
						$clv .= $a[$c] . (8 - $r) . $a[$x - 1] . (8 - ($y + 1)) . ",";
						$x--; $y++;
					}
					if ( $clp[$y + 1][$x - 1][0] == $o && $y + 1 < 8 && $x - 1 >= 0 ) $clv .= $a[$c] . (8 - $r) . $a[$x - 1] . (8 - ($y + 1)) . ",";
					
					$x = $c; $y = $r;
					while ( $clp[$y + 1][$x + 1] == '' && $y + 1 < 8 && $x + 1 < 8 )
					{
						$clv .= $a[$c] . (8 - $r) . $a[$x + 1] . (8 - ($y + 1)) . ",";
						$x++; $y++;
					}
					if ( $clp[$y + 1][$x + 1][0] == $o && $y + 1 < 8 && $x + 1 < 8 ) $clv .= $a[$c] . (8 - $r) . $a[$x + 1] . (8 - ($y + 1)) . ",";
				}
				break;
				case $cs . 'R' :
				{
					$x = $c; $y = $r;
					while ( $clp[$y][$x - 1] == '' && $x - 1 >= 0 )
					{
						$clv .= $a[$c] . (8 - $r) . $a[$x - 1] . ",";
						$x--;
					}
					if ( $clp[$y][$x - 1][0] == $o && $x - 1 >= 0 ) $clv .= $a[$c] . (8 - $r) . $a[$x - 1] . ",";
					
					$x = $c; $y = $r;
					while ( $clp[$y - 1][$x] == '' && $y - 1 >= 0 )
					{
						$clv .= $a[$c] . (8 - $r) . (8 - ($y - 1)) . ",";
						$y--;
					}
					if ( $clp[$y - 1][$x][0] == $o && $y - 1 >= 0 ) $clv .= $a[$c] . (8 - $r) . (8 - ($y - 1)) . ",";
					
					$x = $c; $y = $r;
					while ( $clp[$y + 1][$x] == '' && $y + 1 < 8 )
					{
						$clv .= $a[$c] . (8 - $r) . (8 - ($y + 1)) . ",";
						$y++;
					}
					if ( $clp[$y + 1][$x][0] == $o && $y + 1 < 8 ) $clv .= $a[$c] . (8 - $r) . (8 - ($y + 1)) . ",";
					
					$x = $c; $y = $r;
					while ( $clp[$y][$x + 1] == '' && $x + 1 < 8 )
					{
						$clv .= $a[$c] . (8 - $r) . $a[$x + 1] . ",";
						$x++;
					}
					if ( $clp[$y][$x + 1][0] == $o && $x + 1 < 8 ) $clv .= $a[$c] . (8 - $r) . $a[$x + 1] . ",";
				}
				break;
				case $cs . 'Q' :
				{
					$x = $c; $y = $r;
					while ( $clp[$y][$x - 1] == '' && $x - 1 >= 0 )
					{
						$clv .= $a[$c] . (8 - $r) . $a[$x - 1] . ",";
						$x--;
					}
					if ( $clp[$y][$x - 1][0] == $o && $x - 1 >= 0 ) $clv .= $a[$c] . (8 - $r) . $a[$x - 1] . ",";
					
					$x = $c; $y = $r;
					while ( $clp[$y - 1][$x] == '' && $y - 1 >= 0 )
					{
						$clv .= $a[$c] . (8 - $r) . (8 - ($y - 1)) . ",";
						$y--;
					}
					if ( $clp[$y - 1][$x][0] == $o && $y - 1 >= 0 ) $clv .= $a[$c] . (8 - $r) . (8 - ($y - 1)) . ",";
					
					$x = $c; $y = $r;
					while ( $clp[$y + 1][$x] == '' && $y + 1 < 8 )
					{
						$clv .= $a[$c] . (8 - $r) . (8 - ($y + 1)) . ",";
						$y++;
					}
					if ( $clp[$y + 1][$x][0] == $o && $y + 1 < 8 ) $clv .= $a[$c] . (8 - $r) . (8 - ($y + 1)) . ",";
					
					$x = $c; $y = $r;
					while ( $clp[$y][$x + 1] == '' && $x + 1 < 8 )
					{
						$clv .= $a[$c] . (8 - $r) . $a[$x + 1] . ",";
						$x++;
					}
					if ( $clp[$y][$x + 1][0] == $o && $x + 1 < 8 ) $clv .= $a[$c] . (8 - $r) . $a[$x + 1] . ",";
					
					$x = $c; $y = $r;
					while ( $clp[$y - 1][$x - 1] == '' && $y - 1 >= 0 && $x - 1 >= 0 )
					{
						$clv .= $a[$c] . (8 - $r) . $a[$x - 1] . (8 - ($y - 1)) . ",";
						$x--; $y--;
					}
					if ( $clp[$y - 1][$x - 1][0] == $o && $y - 1 >= 0 && $x - 1 >= 0 ) $clv .= $a[$c] . (8 - $r) . $a[$x - 1] . (8 - ($y - 1)) . ",";
					
					$x = $c; $y = $r;
					while ( $clp[$y - 1][$x + 1] == '' && $y - 1 >= 0 && $x + 1 < 8 )
					{
						$clv .= $a[$c] . (8 - $r) . $a[$x + 1] . (8 - ($y - 1)) . ",";
						$x++; $y--;
					}
					if ( $clp[$y - 1][$x + 1][0] == $o && $y - 1 >= 0 && $x + 1 < 8 ) $clv .= $a[$c] . (8 - $r) . $a[$x + 1] . (8 - ($y - 1)) . ",";
					
					$x = $c; $y = $r;
					while ( $clp[$y + 1][$x - 1] == '' && $y + 1 < 8 && $x - 1 >= 0 )
					{
						$clv .= $a[$c] . (8 - $r) . $a[$x - 1] . (8 - ($y + 1)) . ",";
						$x--; $y++;
					}
					if ( $clp[$y + 1][$x - 1][0] == $o && $y + 1 < 8 && $x - 1 >= 0 ) $clv .= $a[$c] . (8 - $r) . $a[$x - 1] . (8 - ($y + 1)) . ",";
					
					$x = $c; $y = $r;
					while ( $clp[$y + 1][$x + 1] == '' && $y + 1 < 8 && $x + 1 < 8 )
					{
						$clv .= $a[$c] . (8 - $r) . $a[$x + 1] . (8 - ($y + 1)) . ",";
						$x++; $y++;
					}
					if ( $clp[$y + 1][$x + 1][0] == $o && $y + 1 < 8 && $x + 1 < 8 ) $clv .= $a[$c] . (8 - $r) . $a[$x + 1] . (8 - ($y + 1)) . ",";
				}
				break;
			}
		}
	}
	
	$clv = $clv[ strlen($clv) - 1 ] == ',' ? substr($clv, 0, strlen($clv) - 1) : $clv;
	
	$sign = '';
	
	if ( !empty($kcl) )
	{
		$kcl = explode ( "," , $kcl );
		$sign = '+';
	}

	$valid = "";
	$clv = explode( ",", $clv );

	foreach ( $clv as $v )
	{
		$ovx = ord($v[0]) - 97;
		$ovy = 8 - ((int) $v[1]);

		if ( strlen($v) == 3 )
		{
			$vx = ord($v[2]) < 96 ? $ovx : ord($v[2]) - 97;
			$vy = ord($v[2]) < 96 ? 8 - (int) $v[2] : $ovy;
		}
		else if ( strlen($v) == 4 )
		{
			$vx = ord($v[2]) - 97;
			$vy = 8 - (int) $v[3];
		}
			
		$f = false;

		if ( !empty($sign) )
		{
			foreach ( $kcl as $c )
			{
				$cx = (int) $c[0];
				$cy = (int) $c[1];

				if ( $ovx == $kx && $ovy == $ky )
				{
					if ( chess_posting_square_under_attack ( $cs, $clp, $vx, $vy, $kx, $ky ) == '' ) $f = true;
				}
				else
				{
					if ( $cx == $vx && $cy == $vy ) $f = true;
					else if ( $kx == $cx && $kx == $vx && $ky < $vy && $vy < $cy ) $f = true;
					else if ( $kx == $cx && $kx == $vx && $ky > $vy && $vy > $cy ) $f = true;
					else if ( $ky == $cy && $ky == $vy && $kx < $vx && $vx < $cx ) $f = true;
					else if ( $ky == $cy && $ky == $vy && $kx > $vx && $vx > $cx ) $f = true;
					else if ( ((abs($cy-$ky) - abs($cx-$kx)) == (abs($vy-$cy) - abs($vx-$cx))) && $kx > $vx && $vx > $cx ) $f = true;
					else if ( ((abs($cy-$ky) - abs($cx-$kx)) == (abs($vy-$cy) - abs($vx-$cx))) && $kx < $vx && $vx < $cx ) $f = true;

					if ( $ovx == $kx || $ovy == $ky || abs($ovx - $kx) == abs($ovy - $ky) )
					{
						$ofs_x = $ovx - $kx; $ofs_x = $ofs_x == 0 ? $ofs_x : $ofs_x / abs($ovx - $kx);
						$ofs_y = $ovy - $ky; $ofs_y = $ofs_y == 0 ? $ofs_y : $ofs_y / abs($ovy - $ky);
						$x = $ovx; $y = $ovy;

						while ( $clp[$y + $ofs_y][$x + $ofs_x] == '' && $y + $ofs_y >= 0 && $y + $ofs_y < 8 && $x + $ofs_x >= 0 && $x + $ofs_x < 8 ) { $x += $ofs_x; $y += $ofs_y; }
						if ( ($ofs_x == 0 || $ofs_y == 0) && ($clp[$y + $ofs_y][$x + $ofs_x] == $o . "Q" || $clp[$y + $ofs_y][$x + $ofs_x] == $o . "R") && $y + $ofs_y >= 0 && $y + $ofs_y < 8 && $x + $ofs_x >= 0 && $x + $ofs_x < 8 ) $f = false;
						if ( ($ofs_x != 0 && $ofs_y != 0) && ($clp[$y + $ofs_y][$x + $ofs_x] == $o . "Q" || $clp[$y + $ofs_y][$x + $ofs_x] == $o . "B") && $y + $ofs_y >= 0 && $y + $ofs_y < 8 && $x + $ofs_x >= 0 && $x + $ofs_x < 8 ) $f = false;
					}
				}
			}
		}
		else
		{
			$f = true;
			if ( $ovx == $kx && $ovy == $ky )
			{
				if ( chess_posting_square_under_attack ( $cs, $clp, $vx, $vy, $kx, $ky ) != '' ) $f = false;
			}
			else if ( $ovx == $kx || $ovy == $ky || abs($ovx - $kx) == abs($ovy - $ky) )
			{
				$ofs_x = $ovx - $kx; $ofs_x = $ofs_x == 0 ? $ofs_x : $ofs_x / abs($ovx - $kx);
				$ofs_y = $ovy - $ky; $ofs_y = $ofs_y == 0 ? $ofs_y : $ofs_y / abs($ovy - $ky);

				$x = $kx; $y = $ky;
				while ( $clp[$y + $ofs_y][$x + $ofs_x] == '' && ($x + $ofs_x != $ovx || $y + $ofs_y != $ovy) && $y + $ofs_y >= 0 && $y + $ofs_y < 8 && $x + $ofs_x >= 0 && $x + $ofs_x < 8 ) { $x += $ofs_x; $y += $ofs_y; }

				if ($x + $ofs_x == $ovx && $y + $ofs_y == $ovy)
				{
					$x = $ovx; $y = $ovy;
					while ( $clp[$y + $ofs_y][$x + $ofs_x] == '' && $y + $ofs_y >= 0 && $y + $ofs_y < 8 && $x + $ofs_x >= 0 && $x + $ofs_x < 8 ) { $x += $ofs_x; $y += $ofs_y; }
					if ( ($ofs_x == 0 || $ofs_y == 0) && ($clp[$y + $ofs_y][$x + $ofs_x] == $o . "Q" || $clp[$y + $ofs_y][$x + $ofs_x] == $o . "R") && (($x + $ofs_x != $vx) || ($y + $ofs_y != $vy)) && $y + $ofs_y >= 0 && $y + $ofs_y < 8 && $x + $ofs_x >= 0 && $x + $ofs_x < 8 ) $f = false;
					if ( ($ofs_x != 0 && $ofs_y != 0) && ($clp[$y + $ofs_y][$x + $ofs_x] == $o . "Q" || $clp[$y + $ofs_y][$x + $ofs_x] == $o . "B") && (($x + $ofs_x != $vx) || ($y + $ofs_y != $vy)) && $y + $ofs_y >= 0 && $y + $ofs_y < 8 && $x + $ofs_x >= 0 && $x + $ofs_x < 8 ) $f = false;
				}
			}
		}

		if ( $f ) $valid .= $v . ",";
	}
	$clv = $valid[ strlen($valid) - 1 ] == ',' ? substr($valid, 0, strlen($valid) - 1) : $valid;

	return $sign;
}

function chess_posting_play ()
{
	global $chess_play, $template, $lang, $db, $phpEx, $userdata, $topic_id;
	
	if ( !empty($chess_play['chess_play']) && !empty($chess_play['notation']) )
	{
		$chess_notation = $chess_play['notation'];
		$chess_notification = empty($chess_play['chess_notification']) ? 0 : 1;
			
		if ( preg_match( '/^[BKNQR]?[a-h][1-8][x\-][a-h][1-8](\([BKNQ]\))?$/', $chess_notation ) || $chess_notation == '0-0' || $chess_notation == '0-0-0' )
		{
			$pawn_promote = '';
			
			if ( preg_match( '/^([a-h]2[x\-][a-h]1|[a-h]7[x\-][a-h]8)\([BKNQ]\)$/', $chess_notation ) )
			{
				$pawn_promote = substr($chess_notation, 6, 1);
				$chess_notation = substr($chess_notation, 0, 5);
			}
			
			$chess_info = chess_table_select ( '*', $topic_id, 'Could not obtain chess game data for this topic', 'LIMIT 1' );

			if ( $chess_info  )
			{
				$chess_side = $chess_info['chess_p1_id'] == $userdata['user_id'] ? 'W' : 'B';
				$chess_op_side = $chess_side == 'W' ? 'B' : 'W';
				$chess_en_passant = '';
				
				$notation = $chess_notation;
				if ( $chess_notation == '0-0' )
				{
					$notation = $chess_info['chess_p1_id'] == $userdata['user_id'] ? 'Ke1-g1' : 'Ke8-g8';
				}
				if ( $chess_notation == '0-0-0' )
				{
					$notation = $chess_info['chess_p1_id'] == $userdata['user_id'] ? 'Ke1-c1' : 'Ke8-c8';
				}

				$chess_castle = $chess_info['chess_castle'];
				
				$notation = strlen( $notation ) > 5 ? substr( $notation, 1, 5 ) : $notation;

				$chess_old_col = ord( $notation[0] ) - 97;
				$chess_old_row = 8 - (int) $notation[1];
				$chess_col = ord( $notation[3] ) - 97;
				$chess_row = 8 - (int) $notation[4];

				$notation = substr( $notation, 0, 2 ) . substr( $notation, 3, 2 );
				$notation = $notation[0] . $notation[1] . ($notation[0] == $notation[2] ? "" : $notation[2]) . ($notation[1] == $notation[3] ? "" : $notation[3]);

				if ( strpos( $chess_info['chess_list_valid'], $notation ) !== false )
				{
					$chess_list_valid = '';
					$chess_list_position = explode( ';', $chess_info['chess_list_position'] );
					for( $row = 0; $row < 8; $row++ )
					{
						$chess_list_position[$row] = explode( ',', $chess_list_position[$row] );
					}

					if ( strlen($chess_notation) == 5 && $chess_notation != '0-0-0' && $chess_col != $chess_old_col && $chess_list_position[$chess_row][$chess_col] == '')
					{
						$chess_list_position[$chess_old_row][$chess_col] = '';
						$chess_en_passant = 'ep.';
					}

					$chess_piece = $chess_list_position[$chess_old_row][$chess_old_col];
					$chess_list_position[$chess_old_row][$chess_old_col] = '';
					$chess_list_position[$chess_row][$chess_col] = $chess_piece . $pawn_promote;
				
					if ( (($notation == 'e1c' || $notation == 'e1g') && $chess_piece == 'WK') || (($notation == 'e8c' || $notation == 'e8g' ) && $chess_piece == 'BK') )
					{
						$rock_row = 8 - (int) $notation[1];
						$rock_col = ( $notation[2] == 'c' ) ? 0 : 7;
						$chess_list_position[$rock_row][$rock_col] = '';
						$chess_list_position[$rock_row][($rock_col == 0 ? 3 : 5)] = ($rock_row == 0 ? 'BR' : 'WR');
					}

					if ( (substr( $notation, 0, 2 ) == 'e1') && (($chess_castle & 1) == 0 || ($chess_castle & 2) == 0) )
					{
						$chess_castle |= 3;
					}
					if ( (substr( $notation, 0, 2 ) == 'e8') && (($chess_castle & 4) == 0 || ($chess_castle & 8) == 0) )
					{
						$chess_castle |= 12;
					}
						if ( (substr( $notation, 0, 2 ) == 'h1') && ($chess_castle & 1) == 0 )
					{
						$chess_castle |= 1;
					}
					if ( (substr( $notation, 0, 2 ) == 'a1') && ($chess_castle & 2) == 0 )
					{
						$chess_castle |= 2;
					}
					if ( (substr( $notation, 0, 2 ) == 'h8') && ($chess_castle & 4) == 0 )
					{
						$chess_castle |= 4;
					}
					if ( (substr( $notation, 0, 2 ) == 'a8') && ($chess_castle & 8) == 0 )
					{
						$chess_castle |= 8;
					}

					if ( strlen($chess_notation) == 5 && $chess_notation != '0-0-0' && (abs( $chess_row - $chess_old_row ) == 2) )
					{
						if ( $chess_col - 1 >= 0 && $chess_list_position[$chess_row][$chess_col - 1] == $chess_op_side )
						{
							$chess_list_valid .= ($chess_row == 3) ? chr($chess_col + 96) . "5" . $notation[0] . "6," : chr($chess_col + 96) . "4" . $notation[0] . "3,";
						}

						if ( $chess_col + 1 < 8 && $chess_list_position[$chess_row][$chess_col + 1] == $chess_op_side )
						{
							$chess_list_valid .= ($chess_row == 3) ? chr($chess_col + 98) . "5" . $notation[0] . "6," : chr($chess_col + 98) . "4" . $notation[0] . "3,";
						}
					}

					$chess_checked = chess_posting_check_move( $chess_op_side, $chess_list_position, $chess_list_valid, $chess_castle);
					if ( $chess_list_valid == '' )
					{
						$chess_checked = ( $chess_checked == '+' ) ? '#' : '' ;
					}
			
					for( $row = 0; $row < 8; $row++ )
					{
						$chess_list_position[$row] = implode( ',', $chess_list_position[$row] );
					}
					$chess_list_position = implode( ';', $chess_list_position );

					$chess_move = date('U') . "," . $chess_notation . ( $pawn_promote != '' ? "(" . $pawn_promote . ")" : '' ) . $chess_en_passant . $chess_checked;
					
					$chess_list_move = explode( '|', $chess_info['chess_list_move'] );
					if ( $chess_info['chess_p1_id'] == $userdata['user_id'] )
					{

//
// *** added by Zlodey (for Chess+) ***
$kol_kor = substr_count($chess_list_position,"WK");
$chess_closed = $chess_info['chess_closed'];
if (!$kol_kor AND !$chess_closed)
{
	$bank_or = $chess_info['bank_or'];
	$user_bank = $chess_info['chess_p2_id'];
		$sql= "UPDATE " . USERS_TABLE . "
		SET user_reputation = user_reputation + $bank_or
		WHERE  user_id = $user_bank
		LIMIT 1";
		if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, ' ', '', __LINE__, __FILE__, $sql);
			}
	$chess_closed = 1;
}
// *** added by Zlodey (for Chess+) ***
//

						$chess_list_move[0] = empty($chess_list_move[0]) ? $chess_move : $chess_list_move[0] . ";" . $chess_move;
						if ( $chess_list_valid == '' )
						{
							$chess_list_move[1] = ( $chess_checked == '#' ) ? $chess_list_move[1] . ";" . date('U') . ",1-0" : $chess_list_move[1] . ";" . date('U') . ",-";
							$chess_closed = 1;

//
// *** added by Zlodey (for Chess+) ***
$bank_or = $chess_info['bank_or'];
$user_bank = $chess_info['chess_p1_id'];
$sql= "UPDATE " . USERS_TABLE . " 
	SET user_reputation = user_reputation + $bank_or
	WHERE  user_id = $user_bank
	LIMIT 1";
	if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, ' ', '', __LINE__, __FILE__, $sql);
		}
// *** added by Zlodey (for Chess+) ***
//

						}
					}
					else
					{

//
// *** added by Zlodey (for Chess+) ***
$kol_kor = substr_count($chess_list_position,"BK");
$chess_closed = $chess_info['chess_closed'];
if (!$kol_kor AND !$chess_closed)
{
$bank_or = $chess_info['bank_or'];
$user_bank = $chess_info['chess_p1_id'];
$sql= "UPDATE " . USERS_TABLE . "
	SET user_reputation = user_reputation + $bank_or
	WHERE  user_id = $user_bank
	LIMIT 1";
	if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, ' ', '', __LINE__, __FILE__, $sql);
		}
$chess_closed = 1;
}
// *** added by Zlodey (for Chess+) ***
//

						$chess_list_move[1] = empty($chess_list_move[1]) ? $chess_move : $chess_list_move[1] . ";" . $chess_move;
						if ( $chess_list_valid == '' )
						{
							$chess_list_move[0] = ( $chess_checked == '#' ) ? $chess_list_move[0] . ";" . date('U') . ",0-1" : $chess_list_move[0] . ";" . date('U') . ",-";
							$chess_closed = 1;

//
// *** added by Zlodey (for Chess+) ***
$bank_or = $chess_info['bank_or'];
$user_bank = $chess_info['chess_p2_id'];
$sql= "UPDATE " . USERS_TABLE . "
	SET user_reputation = user_reputation + $bank_or
	WHERE  user_id = $user_bank
	LIMIT 1";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, ' ', '', __LINE__, __FILE__, $sql);
		}
// *** added by Zlodey (for Chess+) ***
//

						}
					}
					$chess_list_move = implode( '|', $chess_list_move );

					$sql = "UPDATE " . CHESS_TABLE . " 
						SET chess_turn = " . ($chess_info['chess_p1_id'] == $userdata['user_id'] ? $chess_info['chess_p2_id'] : $chess_info['chess_p1_id']) . ", 
						chess_list_position = '$chess_list_position', 
						chess_list_valid = '$chess_list_valid', 
						chess_list_move = '$chess_list_move', 
						chess_castle = '$chess_castle'" . 
						($chess_closed ? ", chess_closed = $chess_closed" : ""). " 
						WHERE topic_id = $topic_id 
						LIMIT 1";
					if ( !($result = $db->sql_query($sql)) )
					{
						message_die(GENERAL_ERROR, 'Could not update chess game data for this topic', '', __LINE__, __FILE__, $sql);
					}
				}
			}

			//Un-remarks all codes bellow this line to enable confirmation page after making any moves
			//$template->assign_vars(array(
			//	'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id") . '">')
			//);
			//$message =  $lang['Chess_played'].'<br /><br />' . sprintf($lang['Click_return_topic'], '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id") . '">', '</a>');
			//message_die(GENERAL_MESSAGE, $message);
		}
	}

//
// *** added by Zlodey (for Chess) ***
// $user_id = $userdata['user_id'];
$user_pm = ($chess_info['chess_p1_id'] == $userdata['user_id'] ? $chess_info['chess_p2_id'] : $chess_info['chess_p1_id']);
	$sql = "SELECT user_chess_addpm FROM " . USERS_TABLE . " WHERE user_id = $user_pm LIMIT 1";
	if (!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, " ", '', __LINE__, __FILE__, $sql);
		}
	$tempp = $db->sql_fetchrow($result);
	$chess_addpm = $tempp['user_chess_addpm']; 
if ($chess_addpm)
{
include($phpbb_root_path . 'adr/includes/adr_functions_communicate.'.$phpEx);
$subject = $lang['Topic_Chess'];
$dest = $user_pm;
$message = sprintf("      .  (        )");
adr_send_pm ($dest , $subject  , $message );
}
// *** added by Zlodey (for Chess) ***
//

	redirect(append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id", true));
}

function chess_posting_action ()
{
	global $mode, $chess_delete, $confirm;

	if ( $chess_delete && !$confirm )
	{
		chess_posting_delete ();
	}
	else if ( $mode == 'chess_join' )
	{
		chess_posting_join ();
	}
	else if ( $mode == 'chess_play' )
	{
		chess_posting_play ();
	}
}

//
// *** added by Zlodey (for Chess+)***
// ***   ***
function chess_pipez()
{
global $db, $userdata, $topic_id, $chess_info;
$username = $userdata['username'];
$user_id = $userdata['user_id'];
	$sql = "SELECT chess_list_move, chess_p1_id, chess_p2_id, bank_or FROM " . CHESS_TABLE . "	WHERE topic_id = $topic_id LIMIT 1";
	if (!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, " ", '', __LINE__, __FILE__, $sql);
		}
	$temp1 = $db->sql_fetchrow($result);
	$chess_list_move = $temp1['chess_list_move']; 
	$chess_p1_id = $temp1['chess_p1_id']; 
	$chess_p2_id = $temp1['chess_p2_id']; 
	$bank_or = $temp1['bank_or'];

	if ( $chess_p1_id == $user_id ) 
	{
		$chess_list_move = explode( '|', $chess_list_move );
		$chess_list_move[0] = $chess_list_move[0] . ";, <font color=red>" . $username . " </font>";
		$chess_list_move = implode( '|', $chess_list_move );
		$user_id_victory = $chess_p2_id;
	}
	else 
	{
		$chess_list_move = $chess_list_move . ";, <font color=red>" . $username . " </font>";
		$user_id_victory = $chess_p1_id;
	}
		$sql = "UPDATE " . CHESS_TABLE . " SET chess_closed = 1 , chess_turn = 0, chess_list_move = '$chess_list_move' WHERE topic_id = $topic_id LIMIT 1";
		if( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, " ", '', __LINE__, __FILE__, $sql);
			}
		$sql = "UPDATE " . USERS_TABLE . " SET user_reputation = user_reputation + $bank_or WHERE user_id = $user_id_victory LIMIT 1";
		if( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, " ", '', __LINE__, __FILE__, $sql);
			}
}
// ***   ***
// ***   ***
function chess_nich()
{
global $db, $userdata, $topic_id;
$user_id = $userdata['user_id'];
			$sql = "SELECT nich , chess_list_move , chess_p1_id , chess_turn FROM " . CHESS_TABLE . " WHERE topic_id = $topic_id LIMIT 1";
			if (!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, " ", '', __LINE__, __FILE__, $sql);
			}
		$temp3 = $db->sql_fetchrow($result);
		$nich = $temp3['nich'];
		$chess_p1_id = $temp3['chess_p1_id'];
		$chess_list_move = $temp3['chess_list_move'];
		$chess_turn = $temp3['chess_turn'];
	if ($nich != $user_id)
	{
		if ($nich == 0)
		{
		$nich = $user_id;
		$temp4 = ";,?";
		}
		else
		{
		$temp4 = ";,!";
		$chess_turn = 0;
		}
			$chess_list_move = explode( '|', $chess_list_move );
			if ( $chess_p1_id == $user_id ) 
			{
				$chess_list_move[0] = $chess_list_move[0] . " <font color=green>" . $temp4 . "</font>";
				$chess_list_move[1] = $chess_list_move[1] . ";, <font color=green> ---  </font>";
			}
			else 
			{
				$chess_list_move[0] = $chess_list_move[0] . ";, <font color=green> --- </font>";
				$chess_list_move[1] = $chess_list_move[1] . " <font color=green>" . $temp4 . "</font>";
			}
			$chess_list_move = implode( '|', $chess_list_move );
		$sql = "UPDATE " . CHESS_TABLE . " SET nich = '$nich', chess_list_move = '$chess_list_move', chess_turn = $chess_turn WHERE topic_id = $topic_id LIMIT 1";
		if( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, " ", '', __LINE__, __FILE__, $sql);
		}
	}
}
// ***   ***
// *** added by Zlodey (for Chess)***
//

function chess_posting_entry ()
{
	global $template, $board_config, $mode, $is_auth, $chess_id, $phpbb_root_path, $lang, $post_data;
	
	//
	// Chess game entry switch/output
	//
	$template->set_filenames(array(
		'chessbody' => 'chess_posting_body.tpl')
	);
	if( ( $mode == 'newtopic' || $mode == 'editpost' ) && $is_auth['auth_chess_create'] && !$chess_id )
	{

		if ( $board_config['chess_override_user_set'] )
		{
			$chess_set_name = "";
			if( $dir = @opendir($phpbb_root_path . $board_config['chess_set_path'] . "/") )
			{
				while( $sub_dir = @readdir($dir) )
				{
					if( !is_file(phpbb_realpath($phpbb_root_path . $board_config['chess_set_path'] . "/" .$sub_dir)) && !is_link(phpbb_realpath($phpbb_root_path . $board_config['chess_set_path'] . "/" .$sub_dir)) && $sub_dir != "." && $sub_dir != ".." && $sub_dir != "CVS" )
					{
						if( @file_exists(@phpbb_realpath($phpbb_root_path . $board_config['chess_set_path'] . "/" . $sub_dir . "/set.php")) )
						{
							$chess_set_name .= "<option>" . $sub_dir;
						}
					}
				}
			}
	
			$chess_board_name = "";
			if( $dir = @opendir($phpbb_root_path . $board_config['chess_board_path'] . "/") )
			{
				while( $sub_dir = @readdir($dir) )
				{
					if( !is_file(phpbb_realpath($phpbb_root_path . $board_config['chess_board_path'] . "/" .$sub_dir)) && !is_link(phpbb_realpath($phpbb_root_path . $board_config['chess_board_path'] . "/" .$sub_dir)) && $sub_dir != "." && $sub_dir != ".." && $sub_dir != "CVS" )
					{
						if( @file_exists(@phpbb_realpath($phpbb_root_path . $board_config['chess_board_path'] . "/" . $sub_dir . "/board.css")) )
						{
							$chess_board_name .= "<option>" . $sub_dir;
						}
					}
				}
			}
		}

		$template->assign_vars(array(
			'L_ADD_A_CHESS' => $lang['Add_chess'],
			'L_ADD_CHESS_EXPLAIN' => $lang['Add_chess_explain'],
			'L_CHESS_QUESTION' => $lang['Chess_question'],
			'L_CHESS_QUESTION_MESSAGE' => $lang['Chess_question_message'],
			'L_CHESS_SIDE' => $lang['Chess_side'],
			'L_CHESS_WHITE' => $lang['Chess_white'],
			'L_CHESS_BLACK' => $lang['Chess_black'],
			'L_CHESS_POSITION' => $lang['Chess_position'],
			'L_CHESS_TOP' => $lang['Chess_top'],
			'L_CHESS_BOTTOM' => $lang['Chess_bottom'])
		);

		$template->assign_block_vars('switch_chess_create_toggle', array());

		if ( $board_config['chess_override_user_set'] )
		{
			$template->assign_vars(array(
				'L_CHESS_SET_NAME' => $lang['Chess_set_name'],
				'S_CHESS_SET_NAME' => $chess_set_name,
				'L_CHESS_BOARD_NAME' => $lang['Chess_board_name'],
				'S_CHESS_BOARD_NAME' => $chess_board_name)
			);

			$template->assign_block_vars('switch_chess_set_toggle', array());
		}

		$template->assign_var_from_handle('CHESSBOX', 'chessbody');
	}

	if( $mode == 'editpost' && $post_data['delete_chess'] )
	{
		$template->assign_vars(array(
			'L_ADD_A_CHESS' => $lang['Delete_chess'],
			'L_CHESS_DELETE' => $lang['Chess_delete'])
		);
	
		$template->assign_block_vars('switch_chess_delete_toggle', array());

		$template->assign_var_from_handle('CHESSBOX', 'chessbody');
	}
}

$params = array('chess_create' => 'chess_create', 'chess_delete' => 'chess_delete');
while( list($var, $param) = @each($params) )
{
	if ( !empty($HTTP_POST_VARS[$param]) || !empty($HTTP_GET_VARS[$param]) )
	{
		$$var = ( !empty($HTTP_POST_VARS[$param]) ) ? htmlspecialchars($HTTP_POST_VARS[$param]) : htmlspecialchars($HTTP_GET_VARS[$param]);
	}
	else
	{
		$$var = '';
	}
}

if ( !empty($HTTP_POST_VARS['chess_play']) || !empty($HTTP_GET_VARS['chess_play']) )
{
	$params = array('chess_play' => 'chess_play', 'notation' => 'notation', 'chess_notification' => 'chess_notification');
	$chess_play = array();
	while( list($var, $param) = @each($params) )
	{
		if ( !empty($HTTP_POST_VARS[$param]) || !empty($HTTP_GET_VARS[$param]) )
		{
			$chess_play[$var] = ( !empty($HTTP_POST_VARS[$param]) ) ? htmlspecialchars($HTTP_POST_VARS[$param]) : htmlspecialchars($HTTP_GET_VARS[$param]);
		}
		else
		{
			$chess_play[$var] = '';
		}
	}
}

if ( !empty($HTTP_POST_VARS['chess_join']) || !empty($HTTP_GET_VARS['chess_join']) )
{
	$params = array('chess_join' => 'chess_join', 'chess_location' => 'chess_location');
	$chess_join = array();
	while( list($var, $param) = @each($params) )
	{
		if ( !empty($HTTP_POST_VARS[$param]) || !empty($HTTP_GET_VARS[$param]) )
		{
			$chess_join[$var] = ( !empty($HTTP_POST_VARS[$param]) ) ? htmlspecialchars($HTTP_POST_VARS[$param]) : htmlspecialchars($HTTP_GET_VARS[$param]);
		}
		else
		{
			$chess_join[$var] = '';
		}
	}
}

$refresh = $refresh || $chess_create || $chess_delete;


?>